/**********************************************************************
 * Project: AderPlotter
 * Author: Andrew Deren <andrew@adersoftware.com>
 * http://www.adersoftware.com
 * Date: Feb. 2004
 * 
 * This program can be used for educational purposes only. 
 * For any other uses, please contact the author.
 **********************************************************************/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using AderPlotter.Controls;

namespace AderPlotter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private Plotter plotter;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox txtStartX;
		private System.Windows.Forms.TextBox txtEndX;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button cmdApply;
		private System.Windows.Forms.ListView listPlotters;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.TextBox txtEndY;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtStartY;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox txtData;
		private System.Windows.Forms.Panel txtColor;
		private System.Windows.Forms.Button cmdSave;
		private System.Windows.Forms.Button cmdDelete;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		IPlotter currentPlotter;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.plotter = new AderPlotter.Controls.Plotter();
			this.panel1 = new System.Windows.Forms.Panel();
			this.listPlotters = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.cmdApply = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.txtEndX = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtStartX = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtEndY = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtStartY = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.txtData = new System.Windows.Forms.TextBox();
			this.txtColor = new System.Windows.Forms.Panel();
			this.cmdSave = new System.Windows.Forms.Button();
			this.cmdDelete = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// plotter
			// 
			this.plotter.Dock = System.Windows.Forms.DockStyle.Fill;
			this.plotter.EndX = 1F;
			this.plotter.EndY = 8F;
			this.plotter.Location = new System.Drawing.Point(208, 0);
			this.plotter.Name = "plotter";
			this.plotter.SelectedPlotter = null;
			this.plotter.Size = new System.Drawing.Size(456, 382);
			this.plotter.StartX = -1F;
			this.plotter.StartY = -5F;
			this.plotter.TabIndex = 0;
			// 
			// panel1
			// 
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.groupBox2);
			this.panel1.Controls.Add(this.groupBox1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(208, 382);
			this.panel1.TabIndex = 1;
			// 
			// listPlotters
			// 
			this.listPlotters.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.columnHeader1});
			this.listPlotters.FullRowSelect = true;
			this.listPlotters.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
			this.listPlotters.HideSelection = false;
			this.listPlotters.LabelEdit = true;
			this.listPlotters.Location = new System.Drawing.Point(4, 64);
			this.listPlotters.Name = "listPlotters";
			this.listPlotters.Size = new System.Drawing.Size(180, 164);
			this.listPlotters.TabIndex = 6;
			this.listPlotters.View = System.Windows.Forms.View.Details;
			this.listPlotters.SelectedIndexChanged += new System.EventHandler(this.listPlotters_SelectedIndexChanged);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Width = 136;
			// 
			// cmdApply
			// 
			this.cmdApply.Location = new System.Drawing.Point(56, 88);
			this.cmdApply.Name = "cmdApply";
			this.cmdApply.Size = new System.Drawing.Size(68, 23);
			this.cmdApply.TabIndex = 5;
			this.cmdApply.Text = "Apply";
			this.cmdApply.Click += new System.EventHandler(this.cmdApply_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.txtEndY);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.txtStartY);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.txtEndX);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.txtStartX);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.cmdApply);
			this.groupBox1.Location = new System.Drawing.Point(4, 4);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(192, 116);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Window:";
			// 
			// txtEndX
			// 
			this.txtEndX.Location = new System.Drawing.Point(40, 60);
			this.txtEndX.Name = "txtEndX";
			this.txtEndX.Size = new System.Drawing.Size(44, 20);
			this.txtEndX.TabIndex = 3;
			this.txtEndX.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "To:";
			// 
			// txtStartX
			// 
			this.txtStartX.Location = new System.Drawing.Point(40, 36);
			this.txtStartX.Name = "txtStartX";
			this.txtStartX.Size = new System.Drawing.Size(44, 20);
			this.txtStartX.TabIndex = 1;
			this.txtStartX.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(36, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "From:";
			// 
			// txtEndY
			// 
			this.txtEndY.Location = new System.Drawing.Point(136, 60);
			this.txtEndY.Name = "txtEndY";
			this.txtEndY.Size = new System.Drawing.Size(44, 20);
			this.txtEndY.TabIndex = 7;
			this.txtEndY.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(104, 64);
			this.label3.Name = "label3";
			this.label3.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 6;
			this.label3.Text = "To:";
			// 
			// txtStartY
			// 
			this.txtStartY.Location = new System.Drawing.Point(136, 36);
			this.txtStartY.Name = "txtStartY";
			this.txtStartY.Size = new System.Drawing.Size(44, 20);
			this.txtStartY.TabIndex = 5;
			this.txtStartY.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(104, 40);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(40, 23);
			this.label4.TabIndex = 4;
			this.label4.Text = "From:";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.cmdDelete);
			this.groupBox2.Controls.Add(this.cmdSave);
			this.groupBox2.Controls.Add(this.txtColor);
			this.groupBox2.Controls.Add(this.txtData);
			this.groupBox2.Controls.Add(this.listPlotters);
			this.groupBox2.Location = new System.Drawing.Point(4, 124);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(192, 236);
			this.groupBox2.TabIndex = 7;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Plots:";
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(12, 20);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(44, 15);
			this.label5.TabIndex = 8;
			this.label5.Text = "X-Axis:";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(104, 20);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(44, 15);
			this.label6.TabIndex = 9;
			this.label6.Text = "Y-Axis:";
			// 
			// txtData
			// 
			this.txtData.Location = new System.Drawing.Point(8, 16);
			this.txtData.Name = "txtData";
			this.txtData.Size = new System.Drawing.Size(140, 20);
			this.txtData.TabIndex = 7;
			this.txtData.Text = "";
			// 
			// txtColor
			// 
			this.txtColor.BackColor = System.Drawing.Color.DarkBlue;
			this.txtColor.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.txtColor.Cursor = System.Windows.Forms.Cursors.Hand;
			this.txtColor.Location = new System.Drawing.Point(152, 16);
			this.txtColor.Name = "txtColor";
			this.txtColor.Size = new System.Drawing.Size(28, 20);
			this.txtColor.TabIndex = 8;
			this.txtColor.Click += new System.EventHandler(this.txtColor_Click);
			// 
			// cmdSave
			// 
			this.cmdSave.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.cmdSave.Location = new System.Drawing.Point(8, 40);
			this.cmdSave.Name = "cmdSave";
			this.cmdSave.Size = new System.Drawing.Size(60, 20);
			this.cmdSave.TabIndex = 10;
			this.cmdSave.Text = "Save";
			this.cmdSave.Click += new System.EventHandler(this.cmdSave_Click);
			// 
			// cmdDelete
			// 
			this.cmdDelete.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.cmdDelete.Location = new System.Drawing.Point(76, 40);
			this.cmdDelete.Name = "cmdDelete";
			this.cmdDelete.Size = new System.Drawing.Size(56, 20);
			this.cmdDelete.TabIndex = 11;
			this.cmdDelete.Text = "Delete";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 382);
			this.Controls.Add(this.plotter);
			this.Controls.Add(this.panel1);
			this.Name = "MainForm";
			this.Text = "AderPlotter";
			this.panel1.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		protected override void OnLoad(EventArgs e)
		{
			this.txtStartX.Text = plotter.StartX.ToString("F2");
			this.txtEndX.Text = plotter.EndX.ToString("F2");

			this.txtStartY.Text = plotter.StartY.ToString("F2");
			this.txtEndY.Text = plotter.EndY.ToString("F2");

			this.listPlotters.Items.Add("Add New Plot");

			this.listPlotters.Items[0].Selected = true;
		}


		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void cmdApply_Click(object sender, System.EventArgs e)
		{
			float startX=0;
			float startY=0;
			float endX=0;
			float endY=0;

			if (!ConvertToNumber(this.txtStartX.Text, ref startX)) return;
			if (!ConvertToNumber(this.txtStartY.Text, ref startY)) return;
			if (!ConvertToNumber(this.txtEndX.Text, ref endX)) return;
			if (!ConvertToNumber(this.txtEndY.Text, ref endY)) return;

			plotter.StartX = startX;
			plotter.StartY = startY;
			plotter.EndX = endX;
			plotter.EndY = endY;
		}

		private bool ConvertToNumber(string strValue, ref float retValue)
		{
			try
			{
				retValue = Convert.ToSingle(strValue);
				return true;
			}
			catch (OverflowException)
			{
				MessageBox.Show("Overflow!. '" + strValue + "' is too large, or too small.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}
			catch (FormatException)
			{
				MessageBox.Show("'" + strValue + "' cannot be converted to number.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}
		}

		private void listPlotters_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.listPlotters.SelectedItems.Count == 0)
			{
				this.plotter.SelectedPlotter = null;
				this.currentPlotter = null;
			}
			else
			{
				ListViewItem item = this.listPlotters.SelectedItems[0];
				if (item.Tag == null)
				{
					// adding new plotter
					this.txtData.Text = string.Empty;
					this.cmdDelete.Enabled = false;
					this.cmdSave.Text = "Add";
					this.currentPlotter = null;
				}
				else
				{
					this.currentPlotter = (IPlotter)item.Tag;
					this.plotter.SelectedPlotter = currentPlotter;
					this.cmdDelete.Enabled = true;
					this.cmdSave.Text = "Save";
					this.txtData.Text = currentPlotter.ToString();
				}
			}
		}

		ColorDialog colorDlg;
		private void txtColor_Click(object sender, System.EventArgs e)
		{
			if (colorDlg == null)
				colorDlg = new ColorDialog();

			colorDlg.Color = this.txtColor.BackColor;
			if (colorDlg.ShowDialog() == DialogResult.OK)
				this.txtColor.BackColor = colorDlg.Color;
		}

		private void cmdSave_Click(object sender, System.EventArgs e)
		{
			if (currentPlotter == null)
			{
				// adding new one
				if (this.txtData.Text == string.Empty)
					return;

				EvalPlotter eval = new EvalPlotter();
				try
				{
					eval.SetData(this.txtData.Text);
					eval.Init();
					eval.PlotColor = this.txtColor.BackColor;
					float test = eval.GetValue(0);

					this.plotter.AddPlotter(eval);

					string col1 = eval.ToString();
					ListViewItem item = new ListViewItem(col1);
					item.Tag = eval;
					this.listPlotters.Items.Add(item);
					this.listPlotters.SelectedItems.Clear();
					item.Selected = true;
				}
				catch (Exception ex)
				{
					MessageBox.Show("Cannot add plotter: " + ex.Message);
				}
			}
			else
			{
				ListViewItem item = this.listPlotters.SelectedItems[0];
				try
				{
					EvalPlotter eval = (EvalPlotter)currentPlotter;
					eval.SetData(this.txtData.Text);
					eval.Init();
					eval.PlotColor = this.txtColor.BackColor;
					float test = eval.GetValue(0);

					item.Text = eval.ToString();
					this.plotter.Invalidate();
				}
				catch (Exception ex)
				{
					MessageBox.Show("Cannot set plotter: " + ex.Message);
				}

			}
		}
	}
}
